# Addon Info
bl_info = {
	"name": "Physical Celestial Objects",
	"author": "Physical Addons",
	"version": (0, 2, 0),
	"blender": (3, 3, 0),
	"description": "Physical Celestial Objects",
	"location": "World > Celestial Objects",
	"warning": "alpha version (in-development product)",
	"category": "Lighting",
	}

import bpy

from . properties import *
from . ui import *

from . data_classes import *

def get_classes():
	return (
		PA_GeneralSettings,
		PA_NodeReference,
		PA_Exposed,

		PA_PlanetData,
		PA_PlanetInstance,

		PA_OT_NewPlanetInstance,
		PA_OT_RemovePlanetInstance,
		PA_OT_MovePlanetInstance,
		PA_OT_ReinitializeDrivers,

		PA_UL_PlanetList,

		PA_PT_CelestialObjectsTB,
		PA_PT_PlanetTransformTB,
		PA_PT_PlanetDataTB,
		PA_PT_PlanetAtmosphereTB,
		PA_PT_PlanetRingsTB,
	)


def register():
	classes = get_classes()
	for cls in classes:
		bpy.utils.register_class(cls)
	bpy.types.World.pco_general_settings = PointerProperty(type=PA_GeneralSettings)
	bpy.types.World.pco_exposed = PointerProperty(type=PA_Exposed)
	bpy.types.World.pco_planet_slots = CollectionProperty(type=PA_PlanetInstance)
	bpy.types.World.pco_active_planet_index = IntProperty(name="Active planet index", description="Index of active planet instance", default=0)
	bpy.types.Scene.pco_planets = CollectionProperty(type=PA_PlanetData)


def unregister():
	classes = get_classes()
	for cls in classes:
		bpy.utils.unregister_class(cls)
	del bpy.types.World.pco_general_settings
	del bpy.types.World.pco_exposed
	del bpy.types.World.pco_planet_slots
	del bpy.types.World.pco_active_planet_index
	del bpy.types.Scene.pco_planets


if __name__ == "__main__":
	register()
